lighting={
	lightReach:12,
	sunlightAngle: Math.PI * 1.7,
	fakeTorches:[],
	lightIcon: 'light-icon-night',
	initLightRound:function(){
		for(var i=0;i<map.getCurrentLevel().levelSize;i++){
			for(var j=0;j<map.getCurrentLevel().levelSize;j++){
				var tile = map.getTile(i,j);
				tile.light = 0;
				tile.lightVisits = {};
			}
		}
	},
	calculateSunlight: function(){
		lighting.fakeTorches = [];
	
		lighting.sunlightAngle = ((game.getTimeOfDay()/(60*24))*2*Math.PI+Math.PI/2)%(Math.PI*2);
	
		if(lighting.sunlightAngle < 0){
			lighting.sunlightAngle += Math.PI*2
		}
	
		var lights = [];
		
		var level = map.getCurrentLevel();
	
		if(lighting.sunlightAngle > Math.PI *1.25 && lighting.sunlightAngle < Math.PI *1.75){
			for(var i=1;i<level.levelSize-1;i++){
				var tile = map.getTile(i,level.levelSize-1);
				if(tile.penetrated){
					lights.push(tile);
				}
			}
			
			lighting.lightIcon = 'light-icon-noon';
			
		}else if(lighting.sunlightAngle > Math.PI * 1.75 || lighting.sunlightAngle < 0){
			for(var i=1;i<level.levelSize-1;i++){
				var tile = map.getTile(0,i);
				if(tile.penetrated){
					lights.push(tile);
				}
			}
			
			lighting.lightIcon = 'light-icon-evening';
			
		}else if(lighting.sunlightAngle > Math.PI *1.0 && lighting.sunlightAngle < Math.PI *1.25){
			for(var i=1;i<level.levelSize-1;i++){
				var tile = map.getTile(level.levelSize-1,i);
				if(tile.penetrated){
					lights.push(tile);
				}
			}
			
			lighting.lightIcon = 'light-icon-morning';
			
		}else{
			lighting.lightIcon = 'light-icon-night';
		}
			
				
		for(var i=0;i<lights.length;i++){
			var tile = lights[i];
			
			var fakeTorchAdded = false;

			var lightX = tile.i;
			var lightY = tile.j;
			
			var prevTile = tile;
			
			for(var j=0;j<1000;j++){
				lightX += Math.cos(lighting.sunlightAngle)*.5;
				lightY += Math.sin(lighting.sunlightAngle)*.5;
				
				indexX = Math.floor(lightX+.5);
				indexY = Math.floor(lightY+.5);
				
				
				
				var currentTile = map.getTile(
					indexX,
					indexY
				);
				
				currentTile.light = 20;
				
				if(tile.i!=currentTile.i || tile.j!=currentTile.j){
					if(currentTile.opaque){
						if((prevTile.i!=currentTile.i || prevTile.j!=currentTile.j) &&
						(prevTile.i!=tile.i || prevTile.j!=tile.j)){
							lighting.fakeTorches.push(new Torch(prevTile, .55));
						}
						break;
					}
				
					if(!fakeTorchAdded){
						fakeTorchAdded = true;
						lighting.fakeTorches.push(new Torch(currentTile, .55));
					}
				}
				
				if(prevTile.i!=currentTile.i || prevTile.j!=currentTile.j){
					prevTile=currentTile;
				}
			}	
		}
		
		//kill vampires here
		var monsters = map.getCurrentLevel().monsters;
		for(var i=0;i<monsters.length;i++){
			if(monsters[i]!==null && monsters[i].tile.light>=20){
				if(monsters[i].type=="vampire"){
					if(monsters[i].tile.isNearby(player.getTile())){	
						game.playSound("explosion");
					}
				
					monsters[i].hp-=30;
					if(monsters[i].hp<=0){
						
						
						if(monsters[i].name=="Fane"){	
							monsters[i].tile.effects.push(9);
							game.log("Fane explodes in the sunlight!");
						}else{
							game.log("The "+monsters[i].name+" explodes in the sunlight!");
							monsters[i].tile.effects.push(8);
						}
						
						player.xp+=monsters[i].getXpValue();
						monsters[i].die();
						map.getCurrentLevel().destroyMonster(monsters[i].tile);
					}else{
						
						game.log("The sunlight burns the "+monsters[i].name+".");
					}
				}else if(monsters[i].type=="greenman"){
					monsters[i].upgrade();
				}
			}
		}
		
		if(player.isVampire() && player.getTile().light>=20){
			game.log("The sunlight burns you!");
			player.takeDamage(Math.floor(player.maxHealth/3.0));
			player.checkHp();
			
			game.playSound("explosion");
		}
	},
	calculateDynamicLighting:function(){
		var torches = map.getTorches();
		torches = torches.concat(lighting.fakeTorches);


		var candidates;
		
		for(var i=0;i<torches.length;i++){
			var torchTile = torches[i].tile;
		
			//lighting.dynamicVisit(torchTile, 12);
			
			candidates = [torchTile];
			
			
			var torchId = torchTile.id;
			
			for(var step=lighting.lightReach;step>0;step--){
				var roundCandidates = [];
				for(var j=0;j<candidates.length;j++){
					roundCandidates = roundCandidates.concat(
						lighting.dynamicVisit(torchId,candidates[j],step,torches[i])
					);
				}
				
				candidates = roundCandidates;
			}
		}
		
		
		var playerTile = map.getTile(player.x,player.y);
		var playerSurroundingTiles = playerTile.getAllNeighbors();
		playerSurroundingTiles.push(playerTile);
		for(var i=0;i<playerSurroundingTiles.length;i++){
			if(playerSurroundingTiles[i].light < player.visibilityThreshold){
				playerSurroundingTiles[i].light=player.visibilityThreshold;
			}
		}
		
		
		var level = map.getCurrentLevel();
		for(var i=0;i<level.monsters.length;i++){
			if(level.monsters[i]!=null && level.monsters[i].type=="moroi"){
				level.monsters[i].tile.light = player.visibilityThreshold;
				moroiTiles = level.monsters[i].tile.getAllNeighbors();
				for(var j=0;j<moroiTiles.length;j++){
					if(moroiTiles[j].monster==null || moroiTiles[j].monster.type!="moroi"){	
						moroiTiles[j].light = 0;
					}
				}
			}
		}
	},
	dynamicVisit:function(torchId, tile,step, torch){
		if(step==0 || torchId in tile.lightVisits) return [];
		
		tile.lightVisits[torchId] = true;
		
		tile.light+=Math.max(0,1-Math.pow((1-step/lighting.lightReach),2))*torch.getApparentIntensity();
		

		if(tile.opaque) return [];

		var returnNeighbors = [];
		var neighbors = tile.getAdjacentNeighbors();
		for(var i=0;i<neighbors.length;i++){
			if(!(torchId in neighbors[i].lightVisits)){
				returnNeighbors.push(neighbors[i]);
			}
		}
		return returnNeighbors;
	}
};