magic={
	learnedSpells:[null,null,null],
	getSpellLevel:function(x,y,playerCast,spellName){
		if(playerCast){
			return magic.spellLevels[spellName];
		}else{
			return map.getTile(x,y).monster.spellLevel;
		}
	},
	getIntelligenceBonus:function(playerCast){
		if(playerCast){
			return player.getTotalIntelligence()-6;
		}else{
			return 0;
		}
	},
	spells:{
		blast:{
			directional: true,
			cast:function(d,x,y,playerCast){
				game.playSound("blast");
				
				var loc = [x,y];
				for(var i=0;i<playerOffset;i++){
					loc =map.travel(loc[0],loc[1],d);
					var tile = map.getTile(loc[0],loc[1]);
					
					
					var spellLevel = magic.getSpellLevel(x,y,playerCast,"blast");
					var damage = (Math.random()*8+8+magic.getIntelligenceBonus(playerCast))*spellLevel;
					
					if(tile.monster!=null){
						if(tile.monster.type=="golem"){
							tile.monster.hit(damage, "BLAST");
						}else{
							game.log("BLAST has no effect on flesh. Not directly at least.");
						}
					}
					
					if(!tile.isPassable()){
						if(tile.type == "door"){
							tile.openDoor();
							game.log("You BLAST open the "+tile.name+".");
						}else if(tile.type == "wall"){
							
						
							if(tile.wallType=="stained"
							|| (spellLevel >=2 && tile.wallType=="wooden")
							|| (spellLevel >=3  && tile.wallType=="stone")){
								tile.penetrated = true;
								game.log("You BLAST the "+tile.name+".");
							}else{
								game.log("BLAST is not yet powerful enough to go through that, but maybe something weaker....");
							}
						}
						return;
					}
					
					tile.effects.push(48);
				}
			}
		},
		ice:{
			directional: true,
			cast:function(d,x,y,playerCast){
				game.playSound("ice");
			
				var loc = [x,y];
				for(var i=0;i<playerOffset;i++){
					loc =map.travel(loc[0],loc[1],d);
					var tile = map.getTile(loc[0],loc[1]);
					
					if(!tile.isPassable()){
						return;
					}
					
					tile.effects.push(49);
					
					var spellLevel = magic.getSpellLevel(x,y,playerCast,"ice");
					var slow = 3+1*spellLevel;
					var damage = (Math.random()*5+5+magic.getIntelligenceBonus(playerCast))*spellLevel;
					
					if(playerCast){
						if(tile.monster!=null){
							if(!tile.monster.isFriendly()){
								tile.monster.slowCounter = slow;
								tile.monster.hit(damage, "ICE");
							}
							return;
						}
					}else{
						if(tile.monster!=null){
							return;
						}
					
						if(tile.equals(player.getTile())){
							player.slowCounter = slow;
							player.hit(damage,map.getTile(x,y).monster.getArticleName());
							return;
						}
					}
					
				}
			}
		},
		shock:{
			directional: true,
			cast:function(d,x,y,playerCast){
				game.playSound("shock");
				var loc = [x,y];
				for(var i=0;i<playerOffset;i++){
					loc =map.travel(loc[0],loc[1],d);
					var tile = map.getTile(loc[0],loc[1]);
					
					if(!tile.isPassable()){
						return;
					}
					
					tile.effects.push(51);
					
					var spellLevel = magic.getSpellLevel(x,y,playerCast,"shock");
					var damage = (Math.random()*5+5+magic.getIntelligenceBonus(playerCast))*spellLevel;
					if(playerCast){
						if(tile.monster!=null && !tile.monster.isFriendly()){
							tile.monster.hit(damage, "SHOCK");
						}
					}else{
						if(tile.equals(player.getTile())){
							player.hit(damage,map.getTile(x,y).monster.getArticleName());
							return;
						}
					}
				}
			}
		},
		firestorm:{
			directional: false,
			cast:function(d,x,y,playerCast){
				game.playSound("firestorm");
			
				var centerTile = map.getTile(x,y);
				var neighbors = centerTile.getAllNeighbors();
				
				for(var i=0;i<neighbors.length;i++){
					var tile = neighbors[i];
					
					if(tile.isPassable()){
						tile.effects.push(50);
						
						var spellLevel = magic.getSpellLevel(x,y,playerCast,"firestorm");
						var damage = (Math.random()*7+7+magic.getIntelligenceBonus(playerCast))*spellLevel;
						if(playerCast){
							if(tile.monster!=null && !tile.monster.isFriendly()){
								tile.monster.slowCounter = 0;
								tile.monster.hit(damage, "FIRESTORM");
							}
						}else{
							if(tile.equals(player.getTile())){
								player.slowCounter = 0;
								player.hit(damage,map.getTile(x,y).monster.getArticleName());
							}
						}
					}
				}
			}
		},
		silver:{
			directional: true,
			cast:function(d,x,y,playerCast){
				//??? sound
				game.playSound("silver");
			
				var loc = [x,y];
				for(var i=0;i<playerOffset;i++){
					loc =map.travel(loc[0],loc[1],d);
					var tile = map.getTile(loc[0],loc[1]);
					
					if(!tile.isPassable()){
						return;
					}
					
					tile.effects.push(52);
					
					var spellLevel = magic.getSpellLevel(x,y,playerCast,"silver");
					var damage = Math.min(.9, .3 + .05* magic.getIntelligenceBonus(playerCast) + .1*spellLevel);	

					if(playerCast){
						if(tile.monster!=null){
							if(tile.monster.type=="vampire"){
								var hpLoss = tile.monster.hp*(damage);
								tile.monster.hit(hpLoss, "SILVER");
							}
							return;
						}
					}else{
						if(tile.monster!=null){
							return;
						}
						
						if(tile.equals(player.getTile())){
							if(player.isVampire()){
								var hpLoss = player.health*(damage);
								player.hit(hpLoss);
							}
							return;
						}
					}
				}
			}
		},
		heal:{
			directional: false,
			cast:function(d,x,y,playerCast){
				game.playSound("heal");
				
				var spellLevel = magic.getSpellLevel(x,y,playerCast,"heal");
				var damage = (Math.random()*10+10+2*magic.getIntelligenceBonus(playerCast))*spellLevel;	
				
				if(playerCast){
					player.health=Math.min(player.maxHealth,player.health+damage);

				}else{
					var monster = map.getTile(x,y);
					monster.hp=Math.min(monster.maxHp,monster.hp+damage);
				}
			}
		}
	},
	init:function(){
		
		magic.spellLevels = {};
		for(s in magic.spells){
			magic.spellLevels[s]=0;
		}
		magic.learnedSpells = ["blast",null,null];
		for(var i=0;i<magic.learnedSpells.length;i++){
			if(magic.learnedSpells[i]!=null){
				magic.spellLevels[magic.learnedSpells[i]]=1;
			}
		}
		
		
		
		magic.state="idle";
		magic.forgetState="idle";
		magic.selectedSpell= null;
		magic.replacementSpell = null;
	},
	tryLearningSpell:function(spellName){
		for(var i=0;i<magic.learnedSpells.length;i++){
			if(spellName==magic.learnedSpells[i]){
				magic.spellLevels[spellName]++;
				game.log("You level up your "+spellName.toUpperCase()+" spell.");
				return;
			}else if(magic.learnedSpells[i]==null){
				magic.spellLevels[spellName]++;
				magic.learnedSpells[i]=spellName;
				game.log("You learn the "+spellName.toUpperCase()+" spell.");
				return;
			}
		}
		game.log("The book teaches the "+spellName.toUpperCase()+" spell. Press [1-3] to forget a spell or [ESC] to cancel.");
		magic.replacementSpell = spellName;
		magic.forgetState = "waiting";
	},
	forgetSpell:function(spellName){
		if(magic.forgetState="waiting"){
			for(var i=0;i<magic.learnedSpells.length;i++){
				if(spellName==magic.learnedSpells[i]){
					magic.spellLevels[magic.learnedSpells[i]]=0;
					magic.spellLevels[magic.replacementSpell]=1;
				
					magic.learnedSpells[i]=magic.replacementSpell;
					game.log("You learn the "+magic.replacementSpell.toUpperCase()+" spell.");
					magic.forgetState = "idle";
					game.tick(0);
					return;
				}
			}
		}
	},
	draw:function(){
		var buttonHtml = "";
		var disabledClass = "";
		
		if(player.isVampire()){
			disabledClass = "disabled";
		}
		
		for(var i=0;i<magic.learnedSpells.length;i++){
			if(magic.learnedSpells[i]!==null){
				buttonHtml+='<div class="ui-button magic-button '+disabledClass+'" data-spell="'+magic.learnedSpells[i]+'">['+(i+1)+'] '+magic.learnedSpells[i].toUpperCase()+magic.spellLevels[magic.learnedSpells[i]]+'</div>';
			}else{
				buttonHtml+='<div class="ui-button magic-button '+disabledClass+'" data-spell="">['+(i+1)+'] (empty)</div>';
			}
		}
		$("#button-container").html(buttonHtml);
	},
	cast:function(spellName){
		if(player.isVampire()){
			game.log("Vampires cannot cast magic");
			return;
		}
		
		if(spellName != null && spellName != ""){
			var spell = magic.spells[spellName];
		
			magic.selectedSpell= spellName;
			if(spell.directional){
				magic.state = "waiting";
				game.log("Select a direction for "+spellName.toUpperCase()+".");
			}else{
				magic.finishCast(null, player.x,player.y,true);
			}
		}
	},
	finishCast:function(direction,x,y, playerCast){
		var spell = magic.spells[magic.selectedSpell];
		
		spell.cast(direction,x,y,playerCast);

		if(playerCast){
			player.hunger-=(2+magic.spellLevels[magic.selectedSpell]*2)/2.0;
			magic.selectedSpell = null;
			magic.state = "idle";
			game.tick(50.0/player.getTotalDexterity());
		}
	}
}

