map={
	totalLevels: 10,
	init:function(){
		map.levels = [];
		map.levelIndex = 0;
	
		/*
		map.generationOptions = {
			levelSize: 40,
			steps: 4,					//6 or more generally produces open rooms
			hallwayLengthMin: 25,
			hallwayLengthMax: 45,
			roomSizeMin: 3,
			roomSizeMax: 6,
			branchChance: .1,
			torchChance: .06,
			monsterChance: .05,
			doorChance: .5,
			itemChance: .305,
			itemChances:[
				[Sword,		0.1],
				[Shield,	0.1],
				[Armor,		0.1],
				[Gold,		0.1],
				[Book,		0.2],
				[Potion,	0.5],
				[Essence,	0.0]
			]
		};
		*/
	},
	pickLevel:function(level){
		//2 levels above (out of depth)	5
		//next level (out of depth)	15
		//this level	30
		//prev level	15
		//random level below that	35
		
		var r= Math.random();
		if(r<.05){
			return Math.min(8,level+2);
		}else if(r<.20){
			return Math.min(8,level+1);
		}else if(r<.5){
			return Math.min(8,level);
		}else if(r<.65){
			return Math.max(0,level-1);
		}else{
			return map.randRange(0,level);
		}
	},
	pickMonster:function(level){
		var mLevel = map.pickLevel(level);
	
		var monsters= [
			[Grunt],
			[Mercenary],
			[RatSoldier],
			[Runner],
			[Marauder,GreenMan],
			[LapisGolem],
			[RatAssassin,Noble],
			[Solomonar],
			[RubyGolem,Moroi]
		];
		
		var levelMonsters = monsters[mLevel];
		
		return levelMonsters[0,map.randRange(0,levelMonsters.length-1)];
	},
	getCurrentLevel:function(){
		return map.levels[map.levelIndex];
	},
	getDisplayTiles:function(){
		var displayTiles = [];
		for(var i=player.x-playerOffset;i<=player.x+playerOffset;i++){
			for(var j=player.y-playerOffset;j<=player.y+playerOffset;j++){
				displayTiles.push(map.getTile(i,j));
			}
		}
		return displayTiles;
	},
	findTile:function(source,tile){
		for(var i=0;i<source.length;i++){
			if(tile.equals(source[i])){
				return true;
			}
		}
		return false;
	},
	getMonsterDisplayTiles:function(x,y){
		var displayTiles = [];
		for(var i=x-playerOffset;i<=x+playerOffset;i++){
			for(var j=y-playerOffset;j<=y+playerOffset;j++){
				displayTiles.push(map.getTile(i,j));
			}
		}
		return displayTiles;
	},
	//returns LIT torches
	getTorches:function(){
		var litTorches = [];
		var torches = map.getCurrentLevel().torches;
		for(var i=0;i<torches.length;i++){
			if(torches[i].tile.torch==2){
				litTorches.push(torches[i]);
			}
		}
		return litTorches;
	},
	getTile:function(i,j){
		var level = map.getCurrentLevel();
		return level.getTile(i,j);
	},
	draw:function(){
		level = map.getCurrentLevel;
		for(var i=0;i<canvasTiles;i++){
			for(var j=0;j<canvasTiles;j++){
				var drawX = player.x-playerOffset+i;
				var drawY = player.y-playerOffset+j;
			
				var tile=map.getTile(drawX,drawY);

				tile.draw(i,j);
				
				if(tile.monster!=null){
					//tile.monster.draw(i,j);
				}
			}
		}
	},
	drawBlack: function(i,j){
		//ctx.fillStyle = "rgb(11,9,17)";
		//ctx.fillRect(i*tileSize,j*tileSize,tileSize,tileSize);
	},
	drawSunlight:function(){
		level = map.getCurrentLevel;
		for(var i=0;i<canvasTiles;i++){
			for(var j=0;j<canvasTiles;j++){
				var drawX = player.x-playerOffset+i;
				var drawY = player.y-playerOffset+j;
			
				var tile=map.getTile(drawX,drawY);

				if(tile.light>=1 && tile.playerVisible){
					ctx.fillStyle = "rgba(255,255,180,"+Math.min(.90,player.lightingMultiplier*tile.light/40)+")";
					ctx.fillRect(i*tileSize,j*tileSize,tileSize,tileSize);
				}
			}
		}
	},
	drawMap:function(){
		mapCtx.clearRect(0,0,1000,1000);

		var tileBuffer = 5;
		
		for(var i=-tileBuffer;i<map.getCurrentLevel().levelSize+tileBuffer;i++){
			for(var j=-10;j<map.getCurrentLevel().levelSize+tileBuffer;j++){
				var tile=map.getTile(i,j);
				if(tile.explored){
					if(tile.type=="staircase"){
						if(tile.direction == "up"){
							mapCtx.fillStyle = "purple";
						}else{
							mapCtx.fillStyle = "blue";
						}
					}else if(tile.type=="door"){
						mapCtx.fillStyle = "orange";
					}else if(tile.isPassable()){
						mapCtx.fillStyle = "rgba(175,175,175,1)";
					}else{
						mapCtx.fillStyle = "rgba(75,75,75,1)";
					}
					mapCtx.fillRect((i+tileBuffer)*mapTileSize,(j+tileBuffer)*mapTileSize,mapTileSize,mapTileSize);
				}
				
			}
		}

		mapCtx.fillStyle = "rgba(255,0,0,1)";
		mapCtx.fillRect((player.x+tileBuffer)*mapTileSize-3,(player.y+tileBuffer)*mapTileSize-3,mapTileSize+6,mapTileSize+6);		
		mapCtx.fillStyle = "rgba(255,255,255,1)";
		mapCtx.fillRect((player.x+tileBuffer)*mapTileSize,(player.y+tileBuffer)*mapTileSize,mapTileSize,mapTileSize);
	},
	generateAllLevels:function(){
		map.levels = [];
	
		for(var i=0;i<map.totalLevels;i++){
			var level = map.generateLevel(i);
			map.levels.push(level);
			level.generateMonsters();
			level.generateItems();
		}
	},
	generateLevel:function(levelNum){
		if(levelNum==map.totalLevels-1){
			map.generationOptions = {
				levelSize: 10,
				steps: 2,					//6 or more generally produces open rooms
				hallwayLengthMin: 25,
				hallwayLengthMax: 45,
				roomSizeMin: 3,
				roomSizeMax: 6,
				branchChance: .1,
				torchChance: .05,
				monsterChance: 0,
				doorChance: 0,
				itemChance: .2,
				itemChances:[
					[Gold,1]
				]
			};
		}else{
			var steps = map.randRange(3,4);
			var roomSizeMin = map.randRange(2,5);
			var levelSize = map.randRange(40,40);
			if(levelNum==0){
				levelSize = 40;
			}
		
			if(steps==3){
				var baseTorch = .08;
			}else if(steps==4){
				var baseTorch = .05;
			}else if(steps==5){
				var baseTorch = .02;
			}
		
			
			if(levelNum==map.totalLevels-1){
				var woodenWallChance = 0;
			}else if(levelNum>=5){
				var woodenWallChance = .05;
			}else{
				var woodenWallChance = .95;
			}
			
		
			map.generationOptions = {
				levelSize: levelSize,
				steps: steps,					//6 or more generally produces open rooms
				hallwayLengthMin: map.randRange(10,25),
				hallwayLengthMax: map.randRange(30,35),
				roomSizeMin: roomSizeMin,
				roomSizeMax: roomSizeMin*2,
				branchChance: .1,
				torchChance: baseTorch+.001*(9-levelNum),
				monsterChance: .02+0.005*(levelNum),
				doorChance: .5,
				itemChance: .03,
				stainedGlassChance: (9-levelNum)/(9*3),
				woodenWallChance: woodenWallChance,
				itemChances:[
					[Sword,		0.05],
					[Shield,	0.05],
					[Armor,		0.05],
					[Gold,		0.2],
					[Book,		0.1],
					[Potion,	0.35],
					[Essence,	0.0]
				]
			};
		}

		/*
			torchChance: .01*(10-4),
			3	.07
			4	.06
			5	.05
			
		*/
		
		
	
		var level = new Level(levelNum);
		level.levelSize = map.generationOptions.levelSize;
		
		for(var i=0;i<map.generationOptions.levelSize;i++){
			level.tiles[i]=[];
			for(var j=0;j<map.generationOptions.levelSize;j++){
				if((j==0 || j==map.generationOptions.levelSize-1 || i==0 || i==map.generationOptions.levelSize-1) && Math.random()<map.generationOptions.stainedGlassChance){
					level.tiles[i][j]=new StainedGlass(i,j,level);
					if(Math.random()<.15){
						level.tiles[i][j].penetrated=true;
					}
				}else{
					if(Math.random()<map.generationOptions.woodenWallChance){
						level.tiles[i][j]=new WoodenWall(i,j,level);
					}else{
						level.tiles[i][j]=new StoneWall(i,j,level);
					}
				}
			}
		}
		
		if(levelNum==0){
			startingLocation = [
				38,
				27
			];
		}else{
			startingLocation = [
				map.randRange(2,map.generationOptions.levelSize-3),
				map.randRange(map.generationOptions.levelSize-2,map.generationOptions.levelSize-2)
			];
		}
		map.createRoom(
			level,
			startingLocation[0],
			startingLocation[1]
		);
		
		gx=startingLocation[0];
		gy=startingLocation[1];
		
		
		
		map.generationStep(level,gx,gy,map.randRange(0,3),map.generationOptions.steps);
		
		var torchesPlaced = 0;
		
		//TORCHES
		for(var i=0;i<map.generationOptions.levelSize;i++){
			for(var j=0;j<map.generationOptions.levelSize;j++){
				var tile = level.getTile(i,j);
				if(tile.type=="floor"){
					if(levelNum==map.totalLevels-1 && torchesPlaced==0){
						level.torches.push(new Torch(tile,1)); 
						tile.torch = 2
						torchesPlaced++;
					}
				
					if((levelNum<map.totalLevels-1) && Math.random()<map.generationOptions.torchChance){
						level.torches.push(new Torch(tile,1)); 
						tile.torch = map.randRange(1,2);
						torchesPlaced++;
					}
				}
			}
		}
		
		level.setTile(gx,gy,new Floor(gx,gy,level),false);
		
		//DOORS
		for(var i=0;i<map.generationOptions.levelSize;i++){
			for(var j=0;j<map.generationOptions.levelSize;j++){
				var tile = level.getTile(i,j);
				if(Math.random()<map.generationOptions.doorChance){
					var neighbors = tile.getAdjacentNeighbors();
					if((neighbors[0].type=="wall" && neighbors[1].type=="wall"
					&& neighbors[2].type=="floor" && neighbors[3].type=="floor"
					&& (neighbors[2].preferDoor || neighbors[3].preferDoor))
						||
					(neighbors[2].type=="wall" && neighbors[3].type=="wall"
					&& neighbors[0].type=="floor" && neighbors[1].type=="floor"
					&& (neighbors[0].preferDoor || neighbors[1].preferDoor))){
						level.setTile(i,j,new Door(i,j,level),false);
					}
				}
			}
		}
		
		
		level.generateStairs();
		
		if(levelNum==map.totalLevels-1){
			level.placeMonster(Fane);
		}
	
	
		//first level tutorial area
		if(levelNum==0){
			player.x=38;
			player.y=38;
			
			//assume size 40
			for(var i=36;i<40;i++){
				for(var j=27;j<40;j++){
					if((i==37 && j>27) || i== 39 || j== 39 || (j==28 && i>=37)){
						tile = new WoodenWall(i,j,level);
					}else{
						tile = new Floor(i,j,level);
					}
					tile.tutorial=true;
					level.setTile(i,j,tile,true);
				}
			}
			
			var tutorialTiles = [];
			
			
			var brokenGlass = new StainedGlass(39,37,level);
			brokenGlass.penetrated = true;
			tutorialTiles.push(brokenGlass);
			
			brokenGlass = new StainedGlass(39,36,level);
			brokenGlass.penetrated = true;
			tutorialTiles.push(brokenGlass);
			
			brokenGlass = new StainedGlass(39,35,level);
			brokenGlass.penetrated = true;
			tutorialTiles.push(brokenGlass);
			
			tutorialTiles.push(new StainedGlass(39,38,level));
			tutorialTiles.push(new StainedGlass(39,34,level));
			tutorialTiles.push(new StainedGlass(39,33,level));
			tutorialTiles.push(new StainedGlass(39,32,level));
			tutorialTiles.push(new StainedGlass(39,31,level));
			tutorialTiles.push(new StainedGlass(39,30,level));
			tutorialTiles.push(new StainedGlass(39,29,level));
			
			tutorialTiles.push(new Entry(38,39,level));
			
			tutorialTiles.push(new Door(38,28, level));
			
			for(var i=0;i<tutorialTiles.length;i++){
				var t= tutorialTiles[i];
				level.tiles[t.i][t.j]=t;
			}
			
			
			
			var torchTile,monsterTile;
			
			var monsterTile = level.getTile(38,29);
			monsterTile.monster = new Noble(monsterTile);
			level.monsters.push(monsterTile.monster);

			torchTile = level.getTile(38,29);
			torchTile.torch=2;
			level.torches.push(new Torch(torchTile,1));
			
		}
		
		
		
		return level;
	},
	generationStep:function(level,gx,gy,hallwayDirection, stepsLeft){
		if(stepsLeft<=0) return;
	
		var encourageBranching = true;
		
		if(gy<map.generationOptions.levelSize-10
		&& gx<map.generationOptions.levelSize-10
		&& gx>map.generationOptions.levelSize+10){
			encourageBranching = false;
		}
	
		if(!encourageBranching && map.randRange(0,1) < level.getTile(gx,gy).getTimesExplored()) return;
	
		//if(map.getLevelTile(level,gx,gy).isPassable()) return;
	
		var hallwayLength = map.randRange(
			map.generationOptions.hallwayLengthMin,
			map.generationOptions.hallwayLengthMax
		);
		
		for(var j=0;j<hallwayLength;j++){
			newgxy = map.travel(gx,gy,hallwayDirection);
			
			if(newgxy[0]>=1 && newgxy[0]<map.generationOptions.levelSize-1 && newgxy[1]>=1 && newgxy[1]<map.generationOptions.levelSize-1){
				gx=newgxy[0];
				gy=newgxy[1];
				
				//randomly start new generation step
				if(Math.random()<.05){
					map.generationStep(
						level,
						gx,
						gy,
						(hallwayDirection+map.randRange(1,3))%4,
						stepsLeft-1
					);
				}
				
				if(level.getTile(gx,gy).isPassable()){
					level.getTile(gx,gy).generationExplore();
				}else{
					level.setTile(gx,gy,new Floor(gx,gy,level),false);
				}
			}else{
				hallwayDirection = map.randRange(0,3);
			}
			
			//randomly change direction
			if(Math.random()<map.generationOptions.branchChance/4){
				hallwayDirection = map.randRange(0,3);
			}
		}

		map.createRoom(
			level,
			gx,
			gy
		);
		
		hallwayDirection = (hallwayDirection+map.randRange(1,3))%4;
		
		for(var k=0;k<4;k++){
			if(k==0 ||
			Math.random()<map.generationOptions.branchChance * (encourageBranching?2:1)){
				map.generationStep(
					level,
					gx,
					gy,
					(hallwayDirection+k)%4,
					stepsLeft-1
				);
			}
		}
	},
	createRoom:function(level,i,j){
		var w = map.randRange(map.generationOptions.roomSizeMin,map.generationOptions.roomSizeMax);
		var h = map.randRange(map.generationOptions.roomSizeMin,map.generationOptions.roomSizeMax);
		
		var startI = Math.floor(i-w/2);
		var startJ = Math.floor(j-h/2);
		
		var endI = startI+w;
		var endJ = startJ+h;
		
		/*if(Math.random()<.5){
			tile.preferredMonster = "human";
		}else{
			tile.preferredMonster = "vampire";	
		}*/
		
		for(var x = startI; x < endI; x++){
			for(var y = startJ; y < endJ; y++){
				var tile = new Floor(x,y,level);
				
				
				level.setTile(x,y,tile,false);
				
				if(x==startI || x==endI || y==startJ || y == endJ){
					tile.preferDoor = true;
				}
			}
		}
	},
	randRange:function(min,max){
		return Math.floor(Math.random()*(max-min+1))+min;
	},
	travel:function(i,j,direction){
		if(direction == 0) return [i+1,j];
		if(direction == 1) return [i,j-1];
		if(direction == 2) return [i-1,j];
		if(direction == 3) return [i,j+1];
	},
	travelRandomly:function(i,j){
		direction = map.randRange(0,3);
		
		if(direction == 0) return [i+1,j];
		if(direction == 1) return [i,j-1];
		if(direction == 2) return [i-1,j];
		if(direction == 3) return [i,j+1];
	}
}



function Level(index){
	this.index = index;
	
	this.monsters = [];
	this.torches = [];
	this.tiles = []
	
	this.upstairs = [];
	this.downstairs = [];
}

Level.prototype.getTile = function(i,j){
	if(i>=0 && i<this.levelSize && j>=0 && j<this.levelSize){
			return this.tiles[i][j];
		}else{
			return new StoneWall(i,j,this);
		}
}

Level.prototype.setTile = function(i,j,tile, placeOnEdge){
	if((i>=1 && i<this.levelSize-1 && j>=1 && j<this.levelSize-1) || placeOnEdge){
		this.tiles[i][j]=tile;
	}
}

Level.prototype.generateStairs = function(){
	var numStairs = 4;
	var timeout = 3000;
	var tile;
	
	for(var i=0;i<numStairs;i++){
		//up
		if(this.index < map.totalLevels-1){
			for(var j=0;j<timeout;j++){
				tile = this.getTile(map.randRange(2,this.levelSize-3),map.randRange(2,Math.min(33,this.levelSize-3)));
				if(tile.type=="floor" && tile.monster==null && tile.item == null){
					staircase = new Staircase(tile.i,tile.j,this,false);
					staircase.direction = "up";
					staircase.stairNumber = this.upstairs.length;
					this.upstairs.push(staircase);

					this.setTile(staircase.i,staircase.j,staircase);
					break;
					
					
				}
				
				if(j==timeout-1){
					//console.log("STAIR FAIL");
				}
			}
		}
	
		//down
		if(this.index > 0){
			
			for(var j=0;j<timeout;j++){
				tile = this.getTile(map.randRange(2,this.levelSize-3),map.randRange(2,Math.min(33,this.levelSize-3)));
				if(tile.type=="floor" && tile.monster==null && tile.item == null){
					staircase = new Staircase(tile.i,tile.j,this,false);
					staircase.direction = "down";
					staircase.stairNumber = this.downstairs.length;
					this.downstairs.push(staircase);
					
					//keep a staircase reference on level, but don't put it down
					if(this.index < map.totalLevels-1){
						this.setTile(staircase.i,staircase.j,staircase);
					}
					
					break;
				}
				
				if(j==timeout-1){
					//console.log("STAIR FAIL");
				}
			}
		}
	}
}

Level.prototype.placeMonster = function(monsterObj){
	for(var i=0;i<this.levelSize;i++){
		for(var j=0;j<this.levelSize;j++){
			var tile = this.getTile(i,j);
			if(tile.type=="floor" && tile.monster==null && tile.torch ==0 && tile.item==null){
				var monster = new monsterObj(tile);
				tile.monster = monster;
				this.monsters.push(tile.monster);
				
				return;
			}
		}	
	}
}

Level.prototype.generateMonsters = function(){
	for(var i=0;i<this.levelSize;i++){
		for(var j=0;j<this.levelSize;j++){
			var tile = this.getTile(i,j);
			if(tile.type=="floor" && !tile.tutorial){
				if(Math.random()<map.generationOptions.monsterChance){
				
				
					var monsterType = map.pickMonster(this.index);
					var monster = new monsterType(tile);
					
					/*if(tile.preferredMonster=="vampire"){
						var monster = new Grunt(tile);
					}else if(tile.preferredMonster=="human"){
						var monster = new Noble(tile);
					}*/
					
					
					tile.monster = monster;
					this.monsters.push(tile.monster);
				}
			}
		}	
	}
}

Level.prototype.generateItems = function(){
	var chanceTotal = 0;
	for(var i=0;i<map.generationOptions.itemChances.length;i++){
		chanceTotal+=map.generationOptions.itemChances[i][1];
	}

	for(var i=0;i<this.levelSize;i++){
		for(var j=0;j<this.levelSize;j++){
			var tile = this.getTile(i,j);
			if(tile.type=="floor" && tile.torch==0  && !tile.tutorial && tile.monster==null){
				if(Math.random()<map.generationOptions.itemChance){
					var chanceSum = 0;
					var r = Math.random()*chanceTotal;
					for(var k=0;k<map.generationOptions.itemChances.length;k++){
						var c = map.generationOptions.itemChances[k];
						
						if(r>=chanceSum && r<chanceSum+c[1]){
							tile.item=new c[0](tile);
							break;
						}
						chanceSum+=c[1];
					}
				}
			}
		}	
	}
}

Level.prototype.destroyMonster = function(tile){
	for(var i=0;i<this.monsters.length;i++){
		if(this.monsters[i]!==null && tile.equals(this.monsters[i].tile)){
			this.monsters[i].destroyed=true;
			tile.monster = null;
			this.monsters[i]=null;
			
			return;
		}
	}
}